OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
NWidgetResizeBase Class Reference
Hierarchical widgets

Base class for a resizable nested widget. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetResizeBase:

## Public Member Functions
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets.
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget.
void | SetMinimalTextLines (uint8 min_lines, uint8 spacing, FontSize size)
| Set minimal text lines for the widget.
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size.
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual void | SetupSmallestSize (Window *w, bool init_array)=0
| Compute smallest size needed by the widget.
virtual void | FillNestedArray (NWidgetBase **array, uint length)=0
virtual NWidgetCore * | GetWidgetFromPos (int x, int y)=0
| Retrieve a widget by its position.
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted (TextColour highlight_colour)
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | Draw (const Window *w)=0
| Draw the widgets of the tree.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Data Fields
uint | min_x
| Minimal horizontal size of only this widget.
uint | min_y
| Minimal vertical size of only this widget.
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
uint | pos_x
| Horizontal position of top-left corner of the widget in the window.
uint | pos_y
| Vertical position of top-left corner of the widget in the window.
NWidgetBase * | next
| Pointer to next widget in container. Managed by parent container widget.
NWidgetBase * | prev
| Pointer to previous widget in container. Managed by parent container widget.
uint8 | padding_top
| Paddings added to the top of the widget. Managed by parent container widget.
uint8 | padding_right
| Paddings added to the right of the widget. Managed by parent container widget. (parent container may swap this with padding_left for RTL)
uint8 | padding_bottom
| Paddings added to the bottom of the widget. Managed by parent container widget.
uint8 | padding_left
| Paddings added to the left of the widget. Managed by parent container widget. (parent container may swap this with padding_right for RTL)

## Additional Inherited Members
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.

## Detailed Description

Base class for a resizable nested widget.

Definition at line 235 of file widget_type.h.

## Constructor & Destructor Documentation

NWidgetResizeBase::NWidgetResizeBase | ( | WidgetType | tp,
|  | uint | fill_x,
|  | uint | fill_y
| ) |  |

Constructor for resizable nested widgets.

Parameters

  tp | Nested widget type.
  fill_x | Horizontal fill step size, `0` means no filling is allowed.
  fill_y | Vertical fill step size, `0` means no filling is allowed.

Definition at line 805 of file widget.cpp.

References NWidgetBase::fill_x, and NWidgetBase::fill_y.

## Member Function Documentation

void NWidgetResizeBase::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| virtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Reimplemented in NWidgetBackground.

Definition at line 855 of file widget.cpp.

References NWidgetBase::StoreSizePosition().

Referenced by NWidgetMatrix::Draw(), and NWidgetMatrix::GetWidgetFromPos().

void NWidgetResizeBase::SetFill | ( | uint | fill_x,
|  | uint | fill_y
| ) |  |

Set the filling of the widget from initial size.

Parameters

  fill_x | Horizontal fill step size, `0` means no filling is allowed.
  fill_y | Vertical fill step size, `0` means no filling is allowed.

Definition at line 838 of file widget.cpp.

References NWidgetBase::fill_x, and NWidgetBase::fill_y.

Referenced by CargoWidgets(), MakeCargoButtons(), MakeCompanyButtonRows(), MakeNWidget(), MakeNWidgetCompanyLines(), MakePerformanceDetailPanels(), NWidgetLeaf::NWidgetLeaf(), and NWidgetScrollbar::SetupSmallestSize().

void NWidgetResizeBase::SetMinimalSize | ( | uint | min_x,
|  | uint | min_y
| ) |  |

Set minimal size of the widget.

Parameters

  min_x | Horizontal minimal size of the widget.
  min_y | Vertical minimal size of the widget.

Definition at line 816 of file widget.cpp.

References max().

Referenced by AddKey(), CargoWidgets(), DropdownWindow::DropdownWindow(), MakeCompanyButtonRows(), MakeNWidget(), MakeNWidgetCompanyLines(), NWidgetLeaf::NWidgetLeaf(), NWidgetSpacer::NWidgetSpacer(), and NWidgetScrollbar::SetupSmallestSize().

void NWidgetResizeBase::SetMinimalTextLines | ( | uint8 | min_lines,
|  | uint8 | spacing,
|  | FontSize | size
| ) |  |

Set minimal text lines for the widget.

Parameters

  min_lines | Number of text lines of the widget.
  spacing | Extra spacing (eg WD_FRAMERECT_TOP + _BOTTOM) of the widget.
  size | Font size of text.

Definition at line 828 of file widget.cpp.

References GetCharacterHeight(), and min_y.

Referenced by MakeNWidget().

void NWidgetResizeBase::SetResize | ( | uint | resize_x,
|  | uint | resize_y
| ) |  |

Set resize step of the widget.

Parameters

  resize_x | Resize step in horizontal direction, value `0` means no resize, otherwise the step size in pixels.
  resize_y | Resize step in vertical direction, value `0` means no resize, otherwise the step size in pixels.

Definition at line 849 of file widget.cpp.

References NWidgetBase::resize_x, and NWidgetBase::resize_y.

Referenced by CargoWidgets(), MakeCompanyButtonRows(), MakeNWidget(), NWidgetLeaf::NWidgetLeaf(), NWidgetSpacer::NWidgetSpacer(), and NWidgetScrollbar::SetupSmallestSize().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp